## nodejs 10.15.0~dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')
COVTESTS ?= test-cov
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)

ifdef JOBS
  PARALLEL_ARGS = -j $(JOBS)
else
  PARALLEL_ARGS = -J
endif

ifdef ENABLE_V8_TAP
  TAP_V8 := --junitout $(PWD)/v8-tap.xml
  TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
  TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
  V8_BUILD_OPTIONS += i18nsupport=off
endif

ifeq ($(OSTYPE), darwin)
  GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[A-Z]' '[a-z]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=small-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to verbose builds.
# To do quiet/pretty builds, run `make V=` to set V to an empty string,
# or set the V environment variable to an empty string.
V ?= 1

# Use -e to double check in case it's a broken link
# Use $(PWD) so we can cd to anywhere before calling this
available-node = \
  if [ -x $(PWD)/$(NODE) ] && [ -e $(PWD)/$(NODE) ]; then \
		$(PWD)/$(NODE) $(1); \
	elif [ -x `which node` ] && [ -e `which node` ] && [ `which node` ]; then \
		`which node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[a-zA-Z0-9._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
$(NODE_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Release V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi

CODE_CACHE_DIR ?= out/$(BUILDTYPE)/obj/gen
CODE_CACHE_FILE ?= $(CODE_CACHE_DIR)/node_code_cache.cc

ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif
.PHONY: with-code-cache
with-code-cache:
	@echo $(CONFIG_FLAGS)
	$(PYTHON) ./configure $(CONFIG_FLAGS)
	$(MAKE)
	mkdir -p $(CODE_CACHE_DIR)
	out/$(BUILDTYPE)/$(NODE_EXE) --expose-internals tools/generate_code_cache.js $(CODE_CACHE_FILE)
	$(PYTHON) ./configure --code-cache-path $(CODE_CACHE_FILE) $(CONFIG_FLAGS)
	$(MAKE)

.PHONY: test-code-cache
test-code-cache: with-code-cache
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) code-cache

out/Makefile: common.gypi deps/uv/uv.gyp deps/http_parser/http_parser.gyp \
              deps/zlib/zlib.gyp deps/v8/gypfiles/toolchain.gypi \
              deps/v8/gypfiles/features.gypi deps/v8/gypfiles/v8.gyp node.gyp \
              config.gypi
	$(PYTHON) tools/gyp_node.py -f make

config.gypi: configure configure.py
	@if [ -x config.status ]; then \
		./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi config_fips.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	$(RM) -r node_modules
	$(RM) -r gcovr build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) -r .cov_tmp
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/test/cctest/*.gcno

.PHONY: coverage
# Build and test with code coverage reporting.  Leave the lib directory
# instrumented for any additional runs the user may want to make.
# For C++ coverage reporting, this needs to be run in conjunction with configure
#  --coverage.  html coverage reports will be created under coverage/
# Related CI job: node-test-commit-linux-coverage
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	mkdir -p node_modules
	if [ ! -d node_modules/nyc ]; then \
		$(NODE) ./deps/npm install nyc@13 --no-save --no-package-lock; fi
	if [ ! -d gcovr ]; then git clone -b 3.4 --depth=1 \
		--single-branch https://github.com/gcovr/gcovr.git; fi
	if [ ! -d build ]; then git clone --depth=1 \
		--single-branch https://github.com/nodejs/build.git; fi
	if [ ! -f gcovr/scripts/gcovr.orig ]; then \
		(cd gcovr && patch -N -p1 < \
		"$(CURDIR)/build/jenkins/scripts/coverage/gcovr-patches-3.4.diff"); fi
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	mv lib lib_
	NODE_DEBUG=nyc $(NODE) ./node_modules/.bin/nyc instrument --extension .js \
		--extension .mjs --exit-on-error lib_/ lib/
	$(MAKE)

.PHONY: coverage-test
coverage-test: coverage-build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) -r .cov_tmp
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/tracing/*.gcda
	-$(MAKE) $(COVTESTS)
	mv lib lib__
	mv lib_ lib
	mkdir -p coverage .cov_tmp
	$(NODE) ./node_modules/.bin/nyc merge 'out/Release/.coverage' \
		.cov_tmp/libcov.json
	(cd lib && .$(NODE) ../node_modules/.bin/nyc report \
		--temp-dir "$(CURDIR)/.cov_tmp" \
		--report-dir "$(CURDIR)/coverage" \
		--reporter html)
	-(cd out && "../gcovr/scripts/gcovr" --gcov-exclude='.*deps' \
		--gcov-exclude='.*usr' -v -r Release/obj.target \
		--html --html-detail -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	mv lib lib_
	mv lib__ lib
	@echo -n "Javascript coverage %: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@echo -n "C++ coverage %: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-addons-napi bench-addons-build ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(CI_JS_SUITES) \
		$(CI_NATIVE_SUITES)

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-addons-napi
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-addons-napi
	$(MAKE) cctest
	$(MAKE) jstest

# Used by `make coverage-test`
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-addons-napi
	# $(MAKE) cctest
	CI_SKIP_TESTS=core_line_numbers.js $(MAKE) jstest

test-parallel: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) parallel

test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

benchmark/napi/function_call/build/Release/binding.node: \
		benchmark/napi/function_call/napi_binding.c \
		benchmark/napi/function_call/binding.cc \
		benchmark/napi/function_call/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_call" \
		--nodedir="$(shell pwd)"

benchmark/napi/function_args/build/Release/binding.node: \
		benchmark/napi/function_args/napi_binding.c \
		benchmark/napi/function_args/binding.cc \
		benchmark/napi/function_args/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_args" \
		--nodedir="$(shell pwd)"

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.js doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

node_use_openssl = $(shell $(call available-node,"-p" \
		   "process.versions.openssl != undefined"))
test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules
ifeq ($(node_use_openssl),true)
	$(RM) -r test/addons/??_*/
	[ -x $(NODE) ] && $(NODE) $< || node $<
	touch $@
else
	@echo "Skipping .docbuildstamp (no crypto)"
endif

ADDONS_BINDING_GYPS := \
	$(filter-out test/addons/??_*/binding.gyp, \
		$(wildcard test/addons/*/binding.gyp))

ADDONS_BINDING_SOURCES := \
	$(filter-out test/addons/??_*/*.cc, $(wildcard test/addons/*/*.cc)) \
	$(filter-out test/addons/??_*/*.h, $(wildcard test/addons/*/*.h))

ADDONS_PREREQS := config.gypi \
	deps/npm/node_modules/node-gyp/package.json tools/build-addons.js \
	deps/uv/include/*.h deps/v8/include/*.h \
	src/node.h src/node_buffer.h src/node_object_wrap.h src/node_version.h

=== debian/changelog ===
nodejs (10.15.0~dfsg-10) unstable; urgency=medium

  * M-A: same on libnode-dev, nodejs-dev
  * Drop nodejs-dev package.
    Addons should instead:
    + Build-Depends libnode-dev, node-gyp
    + remove dh --with nodejs argument in debian/rules
    + use debhelper >= 10 because it strips and shlibs *.node files

 -- Jérémy Lal <kapouer@melix.org>  Fri, 25 Jan 2019 13:51:37 +0100

nodejs (10.15.0~dfsg-9) unstable; urgency=medium

  * M-A: foreign on nodejs-doc
  * libnode-dev depends libuv1-dev (Closes: #905415)

 -- Jérémy Lal <kapouer@melix.org>  Mon, 21 Jan 2019 08:33:36 +0100

nodejs (10.15.0~dfsg-8) unstable; urgency=medium

  * Suggests npm - because nodejs must not be blocked by it.
    Closes: #918388.
  * Patch to silence buffer deprecations. Closes: #918456.
    This patch is meant to ease migration to testing, and to be
    removed as soon as possible.
    It avoids printing to stderr deprecation warning about
    calling Buffer as a constructor without the new operator.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 06 Jan 2019 11:18:34 +0100

nodejs (10.15.0~dfsg-7) unstable; urgency=medium

  * Add missing shlibs, Closes: #917961.
  * Nodejs 10 is here, Close #914965.
  * libnode-dev: install openssl.cnf in /usr/include/nodejs
  * Recommends npm, Closes: #918388.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 05 Jan 2019 19:48:20 +0100

nodejs (10.15.0~dfsg-6) unstable; urgency=medium

  * nodejs: strict dependency on libnode64

 -- Jérémy Lal <kapouer@melix.org>  Tue, 01 Jan 2019 19:03:27 +0100

nodejs (10.15.0~dfsg-5) experimental; urgency=medium

  * mips(el): -latomic
  * Remove split-dwarf for any arch, only for mips
  * Forgot to export LDFLAGS

 -- Jérémy Lal <kapouer@melix.org>  Sat, 29 Dec 2018 17:16:30 +0100

nodejs (10.15.0~dfsg-4) experimental; urgency=medium

  * CPPFLAGS, CFLAGS -gsplit-dwarf for any arch
    Why would this be reserved to mips anyway.
  * Standards-Version 4.3.0

 -- Jérémy Lal <kapouer@melix.org>  Fri, 28 Dec 2018 11:19:02 +0100

nodejs (10.15.0~dfsg-3) experimental; urgency=medium

  * Add CPPFLAGS += -gsplit-dwarf as well

 -- Jérémy Lal <kapouer@melix.org>  Fri, 28 Dec 2018 10:04:23 +0100

nodejs (10.15.0~dfsg-2) experimental; urgency=medium

  * Add -gsplit-dwarf on mips to work around #829139

 -- Jérémy Lal <kapouer@melix.org>  Fri, 28 Dec 2018 02:38:02 +0100

nodejs (10.15.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.15.0~dfsg
  * copyright:
    + add license for src/large_pages/*
    + remove unused paragraph
  * Build using bundled http-parser (unreleased changes)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 27 Dec 2018 13:30:26 +0100

nodejs (10.14.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.14.0~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Wed, 28 Nov 2018 18:59:19 +0100

nodejs (10.13.0~dfsg-3) experimental; urgency=medium

  * Update uv headers path

 -- Jérémy Lal <kapouer@melix.org>  Thu, 15 Nov 2018 10:50:30 +0100

nodejs (10.13.0~dfsg-2) experimental; urgency=medium

  * Upstream patches for openssl 1.1.1 support
  * Build using shared openssl and depend on it again
  * Test suite assumes embedded openssl.cnf

 -- Jérémy Lal <kapouer@melix.org>  Thu, 01 Nov 2018 21:48:45 +0100

nodejs (10.13.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.13.0~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Tue, 30 Oct 2018 10:26:02 +0100

nodejs (10.12.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.12.0~dfsg
  * openssl: use bundled copy because node is not compatible
    with openssl 1.1.1 right now (and there is no upstream fix).
    On the plus side:
    + this avoids ABI breakage for C++ addons (Closes: #904274)
    + upstream have security support for openssl vulns
    On the down side, it's a policy 4.13 violation.
  * copyright:
    + no longer exclude marked since it is removed
    + drop paragraph for pthread-barrier.h
  * Multiarch and DFHS:
    + patch adding --node-relative-path configuration variable
    + "/usr/lib/<$DEB_HOST_MULTIARCH>/nodejs" for c++ addons
    + "/usr/share/nodejs" for pure javascript modules
    + "/usr/lib/nodejs" for smooth migration of current modules
    + Expose those configuration variables in
      process.config.variables.node_relative_path
      process.config.variables.arch_triplet
    + In particular, if prefix is /usr/local all paths move there.
    + Fix test expecting lib/node, should be lib/nodejs.
    (Closes: #901474)
  * Build using shared libuv1 again (Closes: #905415)
  * Standards-Version 4.2.1
  * Add support for mips64r6el arch (Closes: #905886)
  * Drop libnodeXX-dev in favor of libnode-dev (Closes: #901297)
  * Patch tools/doc to restore old dependencies on marked,
    while waiting for remarked/rehyped modules to be available.
  * sequential/test-http2-session-timeout is a flaky test
  * Add lintian override for test/fixtures/assert-long-line.js,
    false source-is-missing positive.
  * Build using LANG=C
  * Stop excluding tools/gyp because upstream patches it
  * Tighten dependency on nghttp2 >= 1.34.0

 -- Jérémy Lal <kapouer@melix.org>  Wed, 17 Oct 2018 11:24:28 +0200

nodejs (10.4.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.4.0~dfsg
  * libnodeXX-dev Breaks+Replaces nodejs-dev << 10 (Closes: #898024)
  * Standards-Version 4.1.4
  * Copyright:
		+ comment the unexpected change in this BSD-3-clause
    + remove duplicate paragraph
    + remove files
    + add antlr4 with a BSD-3-clause license

 -- Jérémy Lal <kapouer@melix.org>  Mon, 11 Jun 2018 00:12:34 +0200

nodejs (10.3.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.3.0~dfsg
  * Skip performance test
  * Symlink js-yaml to the expected dir for doc build

 -- Jérémy Lal <kapouer@melix.org>  Thu, 31 May 2018 00:38:30 +0200

nodejs (10.1.0~dfsg-1) experimental; urgency=medium

  * New upstream version 10.1.0~dfsg
  * watch file: back to dfsg
  * Drop patches applied upstream


=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 debhelper (>=9.20160114),
 dh-buildinfo,
 pkg-config,
 bash-completion,
 curl,
 procps,
 libkvm-dev [kfreebsd-any],
 gyp (>= 0.1~svn1773),
 openssl (>= 1.1.1~),
 zlib1g-dev,
 libicu-dev,
 libc-ares-dev (>= 1.14~),
 libnghttp2-dev (>= 1.34.0~),
 node-acorn,
 ca-certificates,
 python,
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.20.0~)
Build-Depends-Indep: node-js-yaml,
 node-marked
Standards-Version: 4.3.0
Homepage: http://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-10.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-10.x

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${cdbs:Depends},
 ${misc:Depends},
 libnode64 (= ${binary:Version})
Suggests: ${cdbs:Suggests}
Breaks: ${cdbs:Breaks}
Replaces: ${cdbs:Replaces}
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode__ABI.

Package: nodejs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libnode64 (= ${binary:Version})
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends},
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode64
Section: libs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}, nodejs
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# This needs to run before inclusion of CDBS snippets
debian/control:: debian/control.in debian/watch
DEB_PHONY_RULES += debian/control.in debian/watch
debian/control.in::
	sed $(foreach re,ABI ARCHS BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/control.in.in > debian/control.in

debian/watch::
	sed $(foreach re,BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/watch.in > debian/watch

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20160114)

# Do not install licensecheck please
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Needed by upstream build
#  * recent gyp needed to build using flock
bdeps = pkg-config, bash-completion, curl, procps, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
bdeps +=, openssl (>= 1.1.1~)
bdeps +=, zlib1g-dev
bdeps +=, libicu-dev
bdeps +=, libc-ares-dev (>= 1.14~)
bdeps +=, libnghttp2-dev (>= 1.34.0~)
# bdeps +=, libhttp-parser-dev (>= 2.8~)
bdeps +=, node-acorn
# Needed for tests
bdeps +=, ca-certificates

# Needed by upstream build and binary development package
deps = python
deps +=, libssl-dev (>= 1.1.1~)
deps +=, libuv1-dev (>= 1.20.0~)

CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps)
CDBS_DEPENDS_nodejs-dev = $(deps)
CDBS_DEPENDS_libnode-dev = libuv1-dev

CDBS_RECOMMENDS_nodejs = ca-certificates
CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--without-npm \
--without-snapshot \
--shared \
--shared-zlib \
--shared-cares \
--shared-nghttp2 \
--with-intl=system-icu \
--prefix=/usr \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
--shared-libuv

DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl

# map HOST ARCH AND OS, and if unknown let upstream guess

# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
LDFLAGS += -latomic
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
LDFLAGS += -latomic
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
ifeq ($(DEB_PARALLEL_JOBS),)
JOBS := 1
else ifeq ($(SCHROOT_USER),"buildd")
JOBS := 1
else
JOBS := $(DEB_PARALLEL_JOBS)
endif
export JOBS
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

# build -fPIC
CFLAGS+=-fPIC
CPPFLAGS+=-fPIC
# hardening gyp
CFLAGS+=-g
CPPFLAGS+=-g
CXXFLAGS+=$(CPPFLAGS)
export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

# properly clean files from build, test, python
clean::
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	rm -f node_modules
	rm -rf tools/node_modules
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf deps/acorn/
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links

# remove *.json files from documentation
binary-install/nodejs-doc::
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete

pre-build::
	ln -sTf /usr/lib/nodejs node_modules
	mkdir -p $(NODE_TEST_DIR)
	mkdir -p deps/acorn/dist/
	cp -rf /usr/lib/nodejs/acorn/dist/* deps/acorn/dist/

common-install-arch::

## nodejs 10.15.1~dfsg

=== debian/changelog ===
nodejs (10.15.1~dfsg-2) unstable; urgency=medium

  * Fix Build-Deps and add libssl-dev to libnode-dev.
    Closes: #921074.
  * Refactor deps in debian/rules
  * Declare Breaks properly in rules/control.in.in

 -- Jérémy Lal <kapouer@melix.org>  Fri, 01 Feb 2019 22:18:18 +0100

nodejs (10.15.1~dfsg-1) experimental; urgency=medium

  * New upstream version 10.15.1~dfsg
  * Backport upstream-approved Node 11 openssl 1.1.1a support
    (except a test that was weird to backport).

  [ Mattia Rizzolo ]
  * Add Breaks:node-modern-syslog (<< 1.1.4-2) to libnode64.
    node-modern-syslog before 1.1.4-2 depended on the nodejs
    ABI, but didn't have an appropriate dependency.

 -- Jérémy Lal <kapouer@melix.org>  Thu, 31 Jan 2019 09:54:11 +0100

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,6 @@
  dh-buildinfo,
  pkg-config,
  bash-completion,
- curl,
- procps,
  libkvm-dev [kfreebsd-any],
  gyp (>= 0.1~svn1773),
  openssl (>= 1.1.1~),
@@ -18,6 +16,8 @@
  libicu-dev,
  libc-ares-dev (>= 1.14~),
  libnghttp2-dev (>= 1.34.0~),
+ curl,
+ procps,
  node-acorn,
  ca-certificates,
  python,
@@ -83,6 +83,7 @@
  ${misc:Depends}
 Provides: ${cdbs:Provides}
 Recommends: ${cdbs:Recommends}
+Breaks: ${cdbs:Breaks}
 Replaces: nodejs-legacy
 Conflicts: nodejs-legacy
 Description: evented I/O for V8 javascript - runtime library

=== debian/rules ===
--- 
+++ 
@@ -35,28 +35,30 @@
 
 # Needed by upstream build
 #  * recent gyp needed to build using flock
-bdeps = pkg-config, bash-completion, curl, procps, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
+bdeps = pkg-config, bash-completion, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
 bdeps +=, openssl (>= 1.1.1~)
 bdeps +=, zlib1g-dev
 bdeps +=, libicu-dev
 bdeps +=, libc-ares-dev (>= 1.14~)
 bdeps +=, libnghttp2-dev (>= 1.34.0~)
 # bdeps +=, libhttp-parser-dev (>= 2.8~)
+
+# Needed by dev
+devdeps = libssl-dev (>= 1.1.1~)
+devdeps +=, libuv1-dev (>= 1.20.0~)
+
+# Needed for tests
+bdeps +=, curl, procps,
 bdeps +=, node-acorn
-# Needed for tests
 bdeps +=, ca-certificates
-
-# Needed by upstream build and binary development package
-deps = python
-deps +=, libssl-dev (>= 1.1.1~)
-deps +=, libuv1-dev (>= 1.20.0~)
-
-CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps)
-CDBS_DEPENDS_nodejs-dev = $(deps)
-CDBS_DEPENDS_libnode-dev = libuv1-dev
+bdeps +=, python
+
+CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps), $(devdeps)
+CDBS_DEPENDS_libnode-dev = $(devdeps)
 
 CDBS_RECOMMENDS_nodejs = ca-certificates
 CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
+CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
 CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
 LANG=C
 export LANG

## nodejs 10.15.2~dfsg

=== Makefile ===
--- 
+++ 
@@ -270,7 +270,7 @@
 	tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)
 
 .PHONY: jstest
-jstest: build-addons build-addons-napi bench-addons-build ## Runs addon tests and JS tests
+jstest: build-addons build-addons-napi ## Runs addon tests and JS tests
 	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
 		--skip-tests=$(CI_SKIP_TESTS) \
 		$(CI_JS_SUITES) \
@@ -308,7 +308,7 @@
 test-check-deopts: all
 	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential
 
-benchmark/napi/function_call/build/Release/binding.node: \
+benchmark/napi/function_call/build/$(BUILDTYPE)/binding.node: \
 		benchmark/napi/function_call/napi_binding.c \
 		benchmark/napi/function_call/binding.cc \
 		benchmark/napi/function_call/binding.gyp | all
@@ -317,7 +317,7 @@
 		--directory="$(shell pwd)/benchmark/napi/function_call" \
 		--nodedir="$(shell pwd)"
 
-benchmark/napi/function_args/build/Release/binding.node: \
+benchmark/napi/function_args/build/$(BUILDTYPE)/binding.node: \
 		benchmark/napi/function_args/napi_binding.c \
 		benchmark/napi/function_args/binding.cc \
 		benchmark/napi/function_args/binding.gyp | all
@@ -332,16 +332,16 @@
 DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
 endif
 
-node_use_openssl = $(shell $(call available-node,"-p" \
-		   "process.versions.openssl != undefined"))
+node_use_openssl = $(call available-node,"-p" \
+		   "process.versions.openssl != undefined")
 test/addons/.docbuildstamp: $(DOCBUILDSTAMP_PREREQS) tools/doc/node_modules
-ifeq ($(node_use_openssl),true)
-	$(RM) -r test/addons/??_*/
-	[ -x $(NODE) ] && $(NODE) $< || node $<
-	touch $@
-else
-	@echo "Skipping .docbuildstamp (no crypto)"
-endif
+	@if [ "$(shell $(node_use_openssl))" != "true" ]; then \
+		echo "Skipping .docbuildstamp (no crypto)"; \
+	else \
+		$(RM) -r test/addons/??_*/; \
+		[ -x $(NODE) ] && $(NODE) $< || node $< ; \
+		touch $@; \
+  fi
 
 ADDONS_BINDING_GYPS := \
 	$(filter-out test/addons/??_*/binding.gyp, \
@@ -354,5 +354,3 @@
 ADDONS_PREREQS := config.gypi \
 	deps/npm/node_modules/node-gyp/package.json tools/build-addons.js \
 	deps/uv/include/*.h deps/v8/include/*.h \
-	src/node.h src/node_buffer.h src/node_object_wrap.h src/node_version.h
-

=== deps/openssl/config/Makefile ===
# This Makefile is confirmed to be run only on Linux (CentOS and
# Ubuntu). perl5 and gas(>=2.26) are needed.

UNAME_S := $(shell uname -s)
ifneq ($(UNAME_S),Linux)
  $(error This can be run only on Linux)
endif

PERL    = perl

# Supported architecture list
ARCHS = aix-gcc aix64-gcc BSD-x86_64 \
darwin64-x86_64-cc darwin-i386-cc linux-aarch64 \
linux-armv4 linux-elf linux-x32 linux-x86_64 linux-ppc \
linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x \
solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32

CONFIGURE = ./Configure
# no-comp: against CRIME attack
# no-shared: openssl-cli needs static link
# no-afalgeng: old Linux kernel < 4.0 does not support it
COPTS =  no-comp no-shared no-afalgeng

# disable platform check in Configure
NO_WARN_ENV = CONFIGURE_CHECKER_WARN=1

GITIGNORE = $(OPSSL_SRC)/.gitignore
GENERATE = ./generate_gypi.pl

OPSSL_SRC = ../openssl

# Header files generated with Configure
CFG = opensslconf.h
SRC_CFG = $(OPSSL_SRC)/include/openssl/$(CFG)
INT_CFGS = bn_conf.h dso_conf.h
INT_CFG_DIR = $(OPSSL_SRC)/crypto/include/internal

PHONY = all clean replace
.PHONY: $(PHONY)

all: $(ARCHS) replace

# Configure and generate openssl asm files for each archs
$(ARCHS):
# Remove openssl .gitignore to follow nodejs .gitignore
	if [ -e $(GITIGNORE) ]; then rm $(GITIGNORE); fi
# Confgure asm and generate asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm $@
# Confgure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@

# Replace and copy arch dependent headers
replace:
	cp ./$(CFG).tmpl $(SRC_CFG)
	@for c in $(INT_CFGS); do \
	    cp ./$$c.tmpl $(INT_CFG_DIR)/$$c; \
	done

clean:
	find archs \( -name \*.S -o -name \*.s -o -name \*.asm -o \
	-name \*.gypi -o -name \*.h -o -name \*.pm \) -exec rm "{}" \;

=== debian/changelog ===
nodejs (10.15.2~dfsg-2+rpi1) buster-staging; urgency=medium

  [changes brought forward from 10.15.0~dfsg-10+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Thu, 31 Jan 2019 14:17:56 +0000]
  * Link with libatomic on Raspbian.

 -- Raspbian forward porter <root@raspbian.org>  Thu, 18 Apr 2019 11:32:15 +0000

nodejs (10.15.2~dfsg-2) unstable; urgency=medium

  * Avoid two tests to cause a FTBFS (Closes #919588)
    + test-fs-error-messages fails with eatmydata
    + test-net-listen-after-destroying-stdin is flaky
  * gbp for debian/buster branch

 -- Jérémy Lal <kapouer@melix.org>  Mon, 08 Apr 2019 15:06:40 +0200

nodejs (10.15.2~dfsg-1) unstable; urgency=high

  * New upstream version 10.15.2~dfsg
    Slowloris HTTP Denial of Service with keep-alive
    (CVE-2019-5737)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 28 Feb 2019 15:52:30 +0100

nodejs (10.15.1~dfsg-5) unstable; urgency=medium

  * Install only headers
  * /usr/include/v8 should contain the headers directly

 -- Jérémy Lal <kapouer@melix.org>  Sat, 09 Feb 2019 11:55:56 +0100

nodejs (10.15.1~dfsg-4) experimental; urgency=medium

  * Add libv8-dev symlinks:
    + libv8_libbase.so
    + libv8_libplatform.so
    + libv8_libsampler.so

 -- Jérémy Lal <kapouer@melix.org>  Fri, 08 Feb 2019 16:13:57 +0100

nodejs (10.15.1~dfsg-3) experimental; urgency=medium

  * Provides libv8-dev (Closes: #920329)

 -- Jérémy Lal <kapouer@melix.org>  Fri, 08 Feb 2019 14:25:03 +0100

=== debian/control ===
--- 
+++ 
@@ -40,6 +40,8 @@
 Suggests: ${cdbs:Suggests}
 Breaks: ${cdbs:Breaks}
 Replaces: ${cdbs:Replaces}
+Conflicts: ${cdbs:Conflicts}
+Provides: ${cdbs:Provides}
 Description: evented I/O for V8 javascript (development files)
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an

=== debian/rules ===
--- 
+++ 
@@ -59,7 +59,9 @@
 CDBS_RECOMMENDS_nodejs = ca-certificates
 CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
 CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
-CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
+CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev, libv8-dev
+CDBS_PROVIDES_libnode-dev = libv8-dev
+CDBS_CONFLICTS_libnode-dev = libv8-dev (<= 3.14.5.8-11)
 LANG=C
 export LANG
 DEB_CONFIGURE_NORMAL_ARGS =
@@ -166,6 +168,7 @@
 DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
 ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
 # enable vfp, disable armv7
+LDFLAGS += -latomic
 DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
 else
 # enable armv7 vfpv3
@@ -221,6 +224,7 @@
 	rm -rf test/addons/*/build
 	rm -f config.gypi
 	rm -f config.mk
+	rm -f config.status
 	rm -f test/fixtures/hello.txt
 	rm -rf $(NODE_TEST_DIR)
 	rm -f node_modules
@@ -238,7 +242,3 @@
 pre-build::
 	ln -sTf /usr/lib/nodejs node_modules
 	mkdir -p $(NODE_TEST_DIR)
-	mkdir -p deps/acorn/dist/
-	cp -rf /usr/lib/nodejs/acorn/dist/* deps/acorn/dist/
-
-common-install-arch::

## nodejs 10.15.3~dfsg

=== debian/changelog ===
nodejs (10.15.3~dfsg-1) experimental; urgency=medium

  * New upstream version 10.15.3~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Mon, 11 Mar 2019 09:47:26 +0100

## nodejs 10.19.0~dfsg

=== Makefile ===
--- 
+++ 
@@ -341,7 +341,7 @@
 		$(RM) -r test/addons/??_*/; \
 		[ -x $(NODE) ] && $(NODE) $< || node $< ; \
 		touch $@; \
-  fi
+	fi
 
 ADDONS_BINDING_GYPS := \
 	$(filter-out test/addons/??_*/binding.gyp, \

=== debian/changelog ===
nodejs (10.19.0~dfsg-3ubuntu1) focal; urgency=medium

  * Merge from Debian (LP: #1863463). Remaining changes:
    - debian/control, debian/rules:
      + change node-acorn* build dependencies to node-debbundle-acorn
      + change python build dependency to python2
    - debian/tests/control: change python test dependency to python2
    - debian/patches/python2.patch: explicitly invoke python2 in tests
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing
    - debian/patches/0001-test-move-foafssl-certs-to-fixtures-keys.patch:
      upstream patch to move FOAF+SSL certs to fixtures/keys/

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Tue, 31 Mar 2020 16:26:11 +0200

nodejs (10.19.0~dfsg-3) unstable; urgency=medium

  * Upstream fix (backward-compatible) for ssl 1.1.1e

 -- Jérémy Lal <kapouer@melix.org>  Fri, 20 Mar 2020 12:54:37 +0100

nodejs (10.19.0~dfsg-2) unstable; urgency=medium

  * Install acorn, acorn-walk deps
  * Patch to support acorn 6

 -- Jérémy Lal <kapouer@melix.org>  Thu, 19 Mar 2020 15:05:33 +0100

nodejs (10.19.0~dfsg-1) unstable; urgency=medium

  * New upstream version 10.19.0~dfsg
  * Use shared libhttp-parser again
  * b-d acorn and acorn-walk and fix file install

 -- Jérémy Lal <kapouer@melix.org>  Sat, 14 Mar 2020 20:50:35 +0100

nodejs (10.17.0~dfsg-2ubuntu6) focal; urgency=medium

  * Cherrypick updated foafssl test case keys from master, to unbreak
    tests with new openssl.
  * Update vendorized acorn build for 6.*.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 06 Mar 2020 00:57:55 +0000

nodejs (10.17.0~dfsg-2ubuntu5) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:34:35 +0100

nodejs (10.17.0~dfsg-2ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 12:39:22 +0100

nodejs (10.17.0~dfsg-2ubuntu3) focal; urgency=medium

  * Use python2 in one more place.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 15 Jan 2020 18:37:10 +0000

nodejs (10.17.0~dfsg-2ubuntu2) focal; urgency=medium

  * Use python2 in more places.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 14 Jan 2020 17:44:30 +0000

nodejs (10.17.0~dfsg-2ubuntu1) focal; urgency=medium

  * Lower SECLEVEL in the openssl.cnf used for testing, as in Ubuntu
    SECLEVEL is compiled into openssl, rather than set/unset from system
    openssl.cnf. LP: #1858971
  * Build-depend on python2.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 09 Jan 2020 13:11:24 +0000

nodejs (10.17.0~dfsg-2) unstable; urgency=medium

  * Link to atomic using a patch, LDFLAGS is not enough
    This is at least needed on mipsel.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 25 Oct 2019 11:09:09 +0200

nodejs (10.17.0~dfsg-1) unstable; urgency=medium

  * New upstream version 10.17.0~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Wed, 23 Oct 2019 17:53:03 +0200

nodejs (10.16.3~dfsg-1) unstable; urgency=medium

  * New upstream version 10.16.3~dfsg (Closes: #934885)
  * Avoid two tests to cause a FTBFS (Closes: #919588)
  * Delete applied ssl 1.1.1 compatibility patches
  * Never run tests in parallel to avoid memory exhaustion
  * README: match current modules search paths (Closes: #939001)
  * Fix make-doc patch, simplify make using NODE_PATH
  * B-D pkg-js-tools
  * Tighten dep on libuv1 version

 -- Jérémy Lal <kapouer@melix.org>  Wed, 11 Sep 2019 10:39:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: nodejs
 Section: javascript
 Priority: optional
-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
 Build-Depends: cdbs,
@@ -16,13 +17,15 @@
  libicu-dev,
  libc-ares-dev (>= 1.14~),
  libnghttp2-dev (>= 1.34.0~),
+ pkg-js-tools (>= 0.8.2~),
+ libhttp-parser-dev (>= 2.9.2~),
  curl,
  procps,
- node-acorn,
+ node-debbundle-acorn,
  ca-certificates,
- python,
+ python2,
  libssl-dev (>= 1.1.1~),
- libuv1-dev (>= 1.20.0~)
+ libuv1-dev (>= 1.28.0~)
 Build-Depends-Indep: node-js-yaml,
  node-marked
 Standards-Version: 4.3.0

=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.gz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.gz/,\
dversionmangle=s/~dfsg\d*$//,\
repacksuffix=~dfsg \
https://nodejs.org/dist v(10\.\d+\.\d+)/

## nodejs 10.19.0~dfsg1

=== debian/changelog ===
nodejs (10.19.0~dfsg1-1) buster-security; urgency=medium

  * New upstream version 10.19.0~dfsg1
  * Delete applied ssl 1.1.1 compatibility patches
  * Revert upstream changes to stay compatible with stable libuv1:
    + uv_os_uname is not available
    + test-dgram-address uv returns EINVAL, not EBADF
  * Never run tests in parallel to avoid memory exhaustion
  * Use embedded nghttp2 as upstream rely that much on having
    an updated version of it.
  * Avoid two tests to cause a FTBFS (Closes #919588)
  * Patch for compatibility with libuv1 from stable
  * uv in stable expects EINVAL, not EBADF
  * Link to atomic using a patch, LDFLAGS is not enough
  * Exclude brotli from deps, use system-installed one
    + B-D brotli
    + use upstream patch

 -- Jérémy Lal <kapouer@melix.org>  Mon, 20 Apr 2020 09:44:09 +0200
